// 
// Anpassungen im makefile:
//    ATMega8 => MCU=atmega8 im makefile einstellen
//    lcd-routines.c in SRC = ... Zeile anhngen 
// 
#include <avr/io.h>
#include <stdlib.h>
#include "lcd-routines.h"

#define MESSUNGEN 10	// Anzahl der Messungen
 
// Beispiel

 
int main(void)
{
	char buffer[20];
	int result = 0;
	
	lcd_init();	// LCD initialisieren
	 													
	ADMUX = 0;					      							// Kanal waehlen
	ADMUX |= (1<<REFS1) | (1<<REFS0); 								// externe Referenzspannung nutzen
	
	ADCSRA = (1<<ADEN) | (1<<ADPS1) | (1<<ADPS0) | (1<<ADPS2);  	// Frequenzvorteiler 
																	// setzen auf 128 (1) und ADC aktivieren (1)
	/* nach Aktivieren des ADC wird ein "Dummy-Readout" empfohlen, man liest
	   also einen Wert und verwirft diesen, um den ADC "warmlaufen zu lassen" */
	ADCSRA |= (1<<ADSC);              								// eine ADC-Wandlung 
	while ( ADCSRA & (1<<ADSC) ) {;}    							// auf Abschluss der Konvertierung warten 
	result = ADC;  												// ADCW muss einmal gelesen werden,
																	// sonst wird Ergebnis der nchsten Wandlung
	while (1)
	{															// nicht bernommen.
		/* Eigentliche Messung - Mittelwert aus einer Anzahl von aufeinanderfolgenden Wandlungen */
		result = 0; 
		for(uint8_t i=0; i<MESSUNGEN; i++ )
		{
			ADCSRA |= (1<<ADSC);            							// eine Wandlung "single conversion"
			while ( ADCSRA & (1<<ADSC) ) {;}   						// auf Abschluss der Konvertierung warten
			result += ADC;		    									// Wandlungsergebnisse aufaddieren
		}
		result /= MESSUNGEN;	// Durchschnitt bilden
		itoa(result, buffer, 10);
		
		lcd_clear();
		lcd_string(buffer);
	}	
}